/* TeamSCOPE - Software for Collaborative Project Environments.
   Copyright (C) 1999, 2000 Michigan State University.
   Written by Ben Pfaff <pfaffben@msu.edu>.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To contact the TeamSCOPE team, send email to scope@cscw.msu.edu, or
   write to Charles Steinfield, Room 436 Communication Arts Building,
   Michigan State University, Department of Telecommunication, East
   Lansing MI 48824-1212. */

#if !buffer_h
#define buffer_h 1

#include <stddef.h>

struct line;
struct session;

void buf_open_session (struct session *);
void buf_close_session (struct session *);

struct line *buf_create_line (char *s);
void buf_write_line (struct session *, struct line *);
void buf_write_string (struct session *, const char *string);
void buf_write_printf (struct session *, const char *format, ...)
     attribute ((format (printf, 2, 3)));
void buf_flush (struct session *);

const char *buf_read_line (struct session *, int poll);

#endif /* buffer.h */
