/* Let's tell EMACS what language this is: -*- C -*- */

/* Define to get lots of info printed by functions. */
/*#define DEBUGGING 1*/

#if DEBUGGING
#define GLOBAL_DEBUGGING 1
#endif

/* Define these if DEBUGGING is off and you want to make certain
   additional optimizations. */
#if !DEBUGGING
/* #define NDEBUG 1 */			/* disable assert() sanity checks */
#endif

#include "debug-print.h"

/* GNU C allows the programmer to declare that certain functions take
   printf-like arguments, never return, etc.  Conditionalize these
   declarations on whether gcc is in use. */
#if __GNUC__ > 1
#define attribute(X) __attribute__ (X)
#else
#define attribute(X)
#endif

/* GNU C allows unused variables and parameters to be declared as
   such. */
#define unused attribute ((__unused__))

/* Environments. */

/* Internationalization. */
#include <libintl.h>

#if !ENABLE_NLS
/* If we don't do this then gettext() still monkeys with the string,
   which causes gcc not to do its checking on printf() format
   types. */
#undef gettext
#define gettext(STRING) 			\
	STRING
#endif

#define _(STRING) 				\
	gettext(STRING)
     
#define N_(STRING) 				\
	STRING

/* Even C emulation of alloca counts as an alloca implementation. */
#if C_ALLOCA
#define HAVE_ALLOCA 1
#endif

/* Saves on #if's. */
#if HAVE_ALLOCA && !__CHECKER__
#define local_alloc(X)				\
	alloca(X)

#define local_free(P)				\
	do					\
	  {					\
	  }					\
	while (0)
#elif !__CHECKER__
#define local_alloc(X)				\
	xmalloc (X)
     
#define local_free(P) 				\
	free (P)
#else /* __CHECKER__ */
/* Why define these this way?  Because if you do it this way then if
   you try to free a block returned by local_alloc() with the free()
   function, you get an error message. */
#define local_alloc(X)					\
	((void *) (((char *) (xmalloc (X+16))) + 16))

#define local_free(P)				\
	free (((char *) P) - 16)
#endif /* __CHECKER__ */

#if HAVE_ALLOCA && __GNUC__ 
#define local_strdup(S)				\
	({					\
          const char *_olds = (S);		\
          size_t _n = strlen (_olds) + 1;	\
	  char *_news = local_alloc (_n);	\
	  memcpy (_news, _olds, _n);		\
	})
#else
#define local_strdup(S) 			\
	strdup(S)
#endif
