/* TeamSCOPE - Software for Collaborative Project Environments.
   Copyright (C) 1999, 2000, 2001 Michigan State University.
   Written by Ben Pfaff <pfaffben@msu.edu>.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To contact the TeamSCOPE team, send email to scope@cscw.msu.edu, or
   write to Charles Steinfield, Room 436 Communication Arts Building,
   Michigan State University, Department of Telecommunication, East
   Lansing MI 48824-1212. */

#if !activityP_h
#define activityP_h 1

/* All categories for the cat member of activity.query. */
#define ALL_CATS				\
	((1 << AC_CAT_FILE)			\
	 | (1 << AC_CAT_MSG_BOARD)		\
	 | (1 << AC_CAT_EVENT))

/* A single activity from the `activities' table. */
struct activity 
  {
    char *date;			/* Date. */
    char *s1;			/* Filename or event name. */
    char *user;			/* Responsible user. */
    int cat;			/* One of AC_CAT_*. */
    int type;			/* One of AC_TYPE_*. */
    char *s2;			/* Thread name. */
    int ref_seq;		/* Sequence number of referenced activity. */
  };

void interpret_query (const struct activity_query *,
		      struct activity *, int row);
const char *activity_category_name (int cat);
const char *activity_type_name (int cat, int type);

#endif /* activityP.h */
