/* TeamSCOPE - Software for Collaborative Project Environments.
   Copyright (C) 1999, 2000, 2001 Michigan State University.
   Written by Ben Pfaff <pfaffben@msu.edu>.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   To contact the TeamSCOPE team, send email to scope@cscw.msu.edu, or
   write to Charles Steinfield, Room 436 Communication Arts Building,
   Michigan State University, Department of Telecommunication, East
   Lansing MI 48824-1212. */

#if !scope_db_h
#define scope_db_h 1

#include <time.h>

/* Time at beginning of execution. */
extern time_t cur_time;
extern struct tm cur_tm;

extern struct std *conf;

void connect_db (void);
FILE *open_file (const char *fn, const char *mode);
FILE *open_pipe (const char *cmd, const char *mode);
void close_file (FILE *f, const char *fn);
void close_pipe (FILE *f, const char *cmd);
int file_exists (const char *fn);

#endif /* scope-db.h */
